#include <stdio.h>
#include <stdlib.h>

typedef struct NODO{
	int dato;
	struct NODO * siguiente;
}nodo;

nodo * crear_nodo(int valor);
nodo * insertar_en_lista(nodo * lista, int valor);
void imprimir_lista(nodo * lista);
void cambiar_listas(nodo **lista1, nodo **lista2);
void borrar_lista(nodo **lista);
int main(int argc, char **argv)
{
	nodo * lista = NULL, *otraLista = NULL;
	//Insertamos en la primera lista
	lista = insertar_en_lista(lista,1);
	lista = insertar_en_lista(lista,2);
	lista = insertar_en_lista(lista,3);
	//Insertamos en la segunda lista
	otraLista = insertar_en_lista(otraLista,4);
	otraLista = insertar_en_lista(otraLista,5);
	otraLista = insertar_en_lista(otraLista,6);
	
	printf("La primera lista tiene: ");
	imprimir_lista(lista);
	
	printf("La segunda lista tiene: ");
	imprimir_lista(otraLista);
	
	//Cambiamos las listas
	cambiar_listas(&lista,&otraLista);
	
	printf("\nLuego del cambio\n\n");
	
	printf("La primera lista tiene: ");
	imprimir_lista(lista);
	
	printf("La segunda lista tiene: ");
	imprimir_lista(otraLista);
	
	//Es una buena práctica liberar la memoria reservada
	borrar_lista(&lista);
	borrar_lista(&otraLista);
	return 0;
}

nodo * crear_nodo(int valor){
	nodo * nuevo_nodo = (nodo*)malloc(sizeof(nodo));
	
	if(nuevo_nodo != NULL){
		nuevo_nodo -> dato = valor;
		nuevo_nodo -> siguiente = NULL;
	}
	
	return nuevo_nodo;
}

nodo * insertar_en_lista(nodo * lista, int valor){
	
	nodo * nuevo_nodo = crear_nodo(valor);
	
	//Si la lista está vacía insertamos simplemente el nodo nuevo
	if(lista == NULL){
		lista = nuevo_nodo;
	}else{
		nodo * rec_lista = lista; 
		//Recorrer la lista para insertar al último lugar
		
		while(rec_lista -> siguiente != NULL){
			rec_lista = rec_lista -> siguiente;
		}
		
		rec_lista -> siguiente = nuevo_nodo;
	}
	
	//Devolvemos la lista actualizada
	return lista;
}

void imprimir_lista(nodo * lista){
	
	if(lista != NULL){
		while(lista != NULL){
			printf("%i, ",lista -> dato);
			lista = lista -> siguiente;
		}
		printf("\n");
	}else{
		printf("La lista está vacía\n");
	}
}

void cambiar_listas(nodo **lista1, nodo **lista2){
	
	if(*lista1 != NULL && *lista2 != NULL){
		nodo * nodo_temporal = *lista1;
		
		*lista1 = *lista2;
		*lista2 = nodo_temporal;
	}
	
}

void borrar_lista(nodo **lista){
	
	if(*lista != NULL){
		nodo * aux = *lista;
		
		while(*lista != NULL){
			aux = *lista;
			*lista = (*lista) -> siguiente;
			free(aux);
		}
	}
}

